<!doctype html>
<html>
<head>
  <link rel="stylesheet" href="file:///android_asset/style.css" />
</head>
<body>
  <h2>Classe</h2>
  La Classe <i>Kotlin</i> est abordée selon les points suivants :
  <ul>
    <li>Déclaration</li>
    <li>Propriété</li>
    <li>Objet compagnon</li>
    <li>Fonction</li>
    <li>Qualificatifs</li>
    <li>Héritage</li>
  </ul>

<p>Dans cette partie, le langage <i>Kotlin</i> est parfois mis en perspective
avec le langage <i>Java</i>.</p>

<h3>Déclaration</h3>
<p>Afin d'illustrer la syntaxe du langage <i>Kotlin</i>, un cercle magique
(<i>MagicCircle</i>) est utilisé. Ce dernier possède deux coordonnées :
une abscisse (<code>cx</code>) et une ordonnée (<code>cy</code>).</p>

<p>En <i>Java</i>, cet objet est représenté par une classe <i>MagicCircle</i> avec la
syntaxe suivante :<br>
<pre>
<code>
public class MagicCircle {
  private final int cx;
  private final int cy;

  public MagicCircle(int cx, int cy) {
    this.cx = cx;
    this.cy = cy;
  }

  public int getCx() {
    return cx;
  }

  public int getCy() {
    return cy;
  }
}
</code>
</pre>
</p>
<p>Remarque : La classe <i>MagicCircle</i> possède deux attributs constants
ainsi qu'un constructeur, il prend en paramètre deux entiers, <i>integer</i>,
les coordonnées du centre du cercle magique.
De plus, elle possède deux accesseurs (<i>getter</i>), respectivement pour
<code>cx</code> et <code>cy</code>, ils permettent de retourner ces deux dernières
valeurs.</p>

<p>En <i>Kotlin</i>, la classe <i>MagicCircle</i> a la syntaxe suivante :<br>
<pre>
<code>
data class MagicCircle(val cx: Int, val cy: Int)
</code>
</pre></p>
<p>Le mot clé <code>data</code> indique que la classe représente une donnée. Cela permet
d'avoir accès a des fonctions écrites automatiquement par <i>Kotlin</i>, tel que
la fonction <code>equals()</code>, <code>hascode()</code>, <code>toString()</code>...<br>
Le constructeur est écrit dans la déclaration de la classe, de manière implicite.
Il prend en paramètre deux entiers, <i>Int</i>. Ces derniers sont déclarés comme
étant des constantes via le mot clé <code>val</code>, cela a pour effet de les
déclarer comme étant des attributs de la classe <i>MagicCircle</i>. D'une pierre
deux coups, dans la déclaration de la classe, il y a la déclaration du constructeur
ainsi que les attributs de classe.<br>
De plus, comme les attributs de classe sont constants, on peut seulement y accéder,
il n'est pas posssible de les modifier. Il n'y a pas besoin d'écrire les <i>getter</i>,
ils sont implicites.</p>

<p>La classe <i>MagicCircle</i> pourrait également avoir la syntaxe suivante,
en <i>Kotlin</i> :<br>
<pre>
<code>
class MagicCircle {
  var cx = 0
  var cy = 0

  constructor(cx:Int, cy:Int) {
    this.cx = cx
    this.cy = cy
  }
}
</code>
</pre></p>
<p>Remarque : C'est une deuxième façon d'écrire un constructeur, de manière explicite,
via le mot clé <code>constructor</code>. Dans ce cas, les attributs de classe
sont déclarés à l'intérieur de la classe (dans les accolades). Le mot
clé <code>var</code> indique la mutabilité des attributs, ils sont initialisés
avec la valeur 0, puis leurs valeurs sont réassignées dans le constructeur (ils
ne sont donc plus constants).
</p>

<p>Finalement, en <i>Kotlin</i>, il y a deux types de constructeurs :<br>
<ul>
<li>constructeur implicite : placé dans la déclaration de la classe</li>
<li>constructeur explicite : déclaré via le mot clé <code>constructor</code></li>
</ul>
</p>

<h3>Propriété</h3>
Dans l'exemple, du cercle magique, <i>MagicCircle</i>, il y a deux propriétés :
<code>cx</code> et <code>cy</code>. Retenons, la syntaxe avec le constructeur explicite : <br>
 <pre>
 <code>
 class MagicCircle {
   var cx = 0
   var cy = 0

   constructor(cx:Int, cy:Int) {
     this.cx = cx
     this.cy = cy
   }
 }
 </code>
 </pre></p>
<p>Il est alors possible de créer une instance de <i>MagicCircle</i> avec la
syntaxe suivante, nommons-là <i>magic</i> :<br>
<pre>
<code>
var magic = MagicCircle(1, 1)
</code>
</pre>
</p>
<p>
Remarque : C'est comme en <i>Java</i>, sans le  mot clé <i>new</i>.
</p>
<p>À présent, il est possible de modifier les attributs de <code>magic</code>
de cette façon :<br>
<pre>
<code>
magic.cx = 3
</code>
</pre>
</p>
<h3>Fonction</h3>
<p>
<pre>
<code>
data class MagicCircle(val cx: Int, val cy: Int) {

  fun move() = cx += 1

}
</code>
</pre>
</p>
  <h4>Partie suivante</h4>
  <a href="file:///android_asset/2B-operateur.html">Variables, Opérateurs, Conditions</a>
